'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @return { array } 面包写数组列表。
 */
function getBreadCrumbs() {
  var breadcrumbs = [];
  if (this.props && this.props.children) {
    breadcrumbs = this.props.children.props.breadcrumbs || [];
    //console.debug(this.props.children.props)
  }
  return Object.assign([], breadcrumbs);
}
function breadcrumbDecorator(component) {
  component.prototype.getBreadCrumbs = getBreadCrumbs;
  return component;
}
breadcrumbDecorator.create = function (breadcrumbs) {
  return function (component) {
    component.defaultProps = Object.assign({}, component.defaultProps || {}, {
      breadcrumbs: breadcrumbs
    });
    return component;
  };
};

exports.default = breadcrumbDecorator;