'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.localeDecorator = localeDecorator;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _mobxReact = require('mobx-react');

var _PureRenderWithLodash = require('./PureRenderWithLodash');

var _PureRenderWithLodash2 = _interopRequireDefault(_PureRenderWithLodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//中转作用
var __r2Locale__;

/**
 * locale翻译替换函数，根据当前str和配置的语言选项替换。
 * @param {string} str 需要被替换的文字
 */
function t(str) {
  if (!this.props.locale) {
    console.error('You must use @inject("locale") to pass this.props.locale');
    return false;
  }
  var _props$locale = this.props.locale,
      defaultLocale = _props$locale.defaultLocale,
      changedLocale = _props$locale.changedLocale;

  if (!defaultLocale) {
    console.error('You must use defaultLocale of store mobx!');
    return;
  }
  if (!__r2Locale__) {
    __r2Locale__ = {};
    defaultLocale.forEach(function (v, k) {
      __r2Locale__[v] = k;
    });
  }
  if (changedLocale) {
    var o = changedLocale[__r2Locale__[str]];
    if (o) {
      return o;
    }
  }
  return str;
}

/*
 * view locale 装饰器
 * @param { string } localePath 国际化文件夹路径，相对于src目录（例如locale传进去就相当于src/locale）
 *                              默认值为locale
 * @this changeLanguage layoutView提供的切换语言Event
 */
function localeDecorator() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'view';
  var localePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'locale';

  return function (component) {
    var _dec, _class, _class2, _temp;

    component.prototype.t = t;
    var ViewComponent = (_dec = (0, _mobxReact.inject)('locale'), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_React$Component) {
      _inherits(ViewComponent, _React$Component);

      function ViewComponent() {
        _classCallCheck(this, ViewComponent);

        return _possibleConstructorReturn(this, (ViewComponent.__proto__ || Object.getPrototypeOf(ViewComponent)).apply(this, arguments));
      }

      _createClass(ViewComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (type === 'layout') {
            //使用记住的语言列表
            if (localStorage.currentLanguage) {
              this.changeLanguage(localStorage.currentLanguage)();
            }
          }
        }
        /**
         * 语言切换，要设置好locale目录
         * @param { string } language 语言，按照文件命名来处理如zh_CN（.js）、en_US（.js）,.js可选
         * @param { function } beforCallback 语言切换前回调函数，可以用于展示加载状态
         * @param { function } afterCallback 语言切换成功回调函数，可以用于关闭加载状态
         */

      }, {
        key: 'changeLanguage',
        value: function changeLanguage(language, beforCallback, afterCallback) {
          var _this2 = this;

          return function (e) {
            _this2.props.locale.changeLanguage(localePath, language, beforCallback, afterCallback);
          };
        }
      }, {
        key: 'render',
        value: function render() {
          if (type === 'layout') {
            //等待语言列表载入后才渲染
            if (localStorage.currentLanguage && !this.props.locale.canRender) {
              return false;
            }
            component.prototype.changeLanguage = this.changeLanguage.bind(this);
          }
          var ComponentProvider = (0, _mobxReact.observer)(component);
          return _react2.default.createElement(ComponentProvider, this.props);
        }
      }]);

      return ViewComponent;
    }(_react2.default.Component), _class2.displayName = component.displayName || component.name, _temp)) || _class) || _class);

    return ViewComponent;
  };
}

exports.default = localeDecorator;