'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

function shouldComponentUpdate() {
  var other_ignore_props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  return function () {
    var nextProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var nextState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    //console.debug(this.props,nextProps)
    if (!nextState) {
      nextState = {};
    }
    var thisProps = this.props || {},
        thisState = this.state || {};

    if (Object.keys(thisProps).length !== Object.keys(nextProps).length || Object.keys(thisState).length !== Object.keys(nextState).length) {
      return true;
    }

    var redux_ignore_props = ['location', 'params', 'routeParams', 'router', 'routes', 'dispatch'];
    var ignore_props = Object.assign([], redux_ignore_props, other_ignore_props);
    //console.debug(ignore_props)
    for (var key in nextProps) {
      //排除redux的一些影响
      if (ignore_props.indexOf(key) === -1) {
        if (thisProps[key] !== nextProps[key] || !(0, _immutable.is)(thisProps[key], nextProps[key])) {
          return true;
        }
      }
    }

    for (var _key in nextState) {
      if (thisState[_key] !== nextState[_key] || !(0, _immutable.is)(thisState[_key], nextState[_key])) {
        return true;
      }
    }
    return false;
  };
}
/* eslint-disable no-param-reassign */
function pureRenderDecorator(ignore) {
  return function (component) {
    var shouldRender = shouldComponentUpdate(ignore);
    component.prototype.shouldComponentUpdate = shouldRender;
    return component;
  };
}
exports.default = pureRenderDecorator;