'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactRouter = require('react-router');

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

require('./polyfill');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

(0, _mobx.useStrict)(true);

/**
 * @param { object } routes 请参考react-router@3.x.x的配置模式，必填
 * @param { object } stores mobx stores
 * @param { array } defaultLocale 默认的语言列表，可空
 * @param { object } domContainer dom节点对象，默认值是document.getElementById('root')
 */
function app(routes, stores, defaultLocale, domContainer) {
  if (defaultLocale) {
    var _desc, _value, _class, _descriptor, _descriptor2;

    var LocaleStore = (_class = function () {
      function LocaleStore() {
        _classCallCheck(this, LocaleStore);

        this.defaultLocale = defaultLocale;

        _initDefineProp(this, 'changedLocale', _descriptor, this);

        _initDefineProp(this, 'canRender', _descriptor2, this);
      }

      _createClass(LocaleStore, [{
        key: 'setChangedLocage',
        value: function setChangedLocage(locale) {
          this.changedLocale = locale;
        }
      }, {
        key: 'setCanRender',
        value: function setCanRender(flag) {
          this.canRender = flag;
        }
        /**
         * 语言切换，要设置好locale目录
         * @param { string } localePath 国际化文件夹路径，相对于src目录（例如locale传进去就相当于src/locale）
         * @param { string } language 语言，按照文件命名来处理如zh_CN（.js）、en_US（.js）,.js可选
         * @param { function } beforCallback 语言切换前回调函数，可以用于展示加载状态
         * @param { function } afterCallback 语言切换成功回调函数，可以用于关闭展示加载状态
         */

      }, {
        key: 'changeLanguage',
        value: function changeLanguage(localePath, language, beforCallback, afterCallback) {
          var _this = this;

          beforCallback && beforCallback();
          //语言切换后，使用localStorage记住，网页重新载入时选择记住的语言
          localStorage.currentLanguage = language;
          //var path = localePath + '/' + language;
          import('src/locale/' + language).then(function (locale) {
            _this.setChangedLocage(locale.default);
            _this.setCanRender(true);
            afterCallback && afterCallback();
          });
        }
      }]);

      return LocaleStore;
    }(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'changedLocale', [_mobx.observable], {
      enumerable: true,
      initializer: null
    }), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'canRender', [_mobx.observable], {
      enumerable: true,
      initializer: function initializer() {
        return false;
      }
    }), _applyDecoratedDescriptor(_class.prototype, 'setChangedLocage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setChangedLocage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setCanRender', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setCanRender'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'changeLanguage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'changeLanguage'), _class.prototype)), _class);

    stores.locale = new LocaleStore();
  }
  function renderApp() {
    var target = domContainer || document.getElementById('root');
    if (target) {
      (0, _reactDom.render)(_react2.default.createElement(
        _mobxReact.Provider,
        stores,
        _react2.default.createElement(_reactRouter.Router, { history: _reactRouter.browserHistory, routes: routes })
      ), target);
    }
  }

  return renderApp;
}

exports.default = app;